<template>
  <section class="post-writer">
    <BaseInput label="Post title" v-model="title" id="post-title" />
    <p>{{ title }}</p>
    <div class="post-writer__row">
      <BaseTextarea
        class="post-writer__column"
        id="markdown"
        v-model="markdown"
      />
      <div class="post-writer__column">
        <p v-html="html"></p>
      </div>
    </div>
  </section>
</template>
<script lang="ts">
import { defineComponent, ref, watch } from "vue"
import { Post } from "@/types"
import BaseInput from "@/components/shared/BaseInput/index.vue"
import BaseTextarea from "@/components/shared/BaseTextarea/index.vue"
import { parse } from "marked"

export default defineComponent({
  props: {
    post: {
      type: Object as () => Post,
      required: true,
    },
  },
  components: {
    BaseInput,
    BaseTextarea,
  },
  setup(props) {
    const title = ref(props.post.title)
    const contentEditable = ref<null | HTMLParagraphElement>(null)
    const markdown = ref(props.post.markdown)
    const html = ref("")

    watch(
      () => markdown.value,
      value => {
        html.value = parse(value)
      },
      { immediate: true }
    )

    return { title, contentEditable, markdown, html }
  },
})
</script>
